<?php
/*

*/

include("KLogger.php");
$log = new KLogger('/tmp', KLogger::DEBUG);
$log->logInfo('GET:  ' . json_encode($_GET));
$log->logInfo('POST:  ' . json_encode($_POST));

require_once(__DIR__ . '/../vendor/autoload.php');
if (!is_file(__DIR__ . '/conf/Configuration.php')) {
    die("Please add your connection credentials to the file \"" . __DIR__ . "/conf/Configuration.php\".\n");
} else {
    require_once(__DIR__ . '/conf/Configuration.php');
}

function cargar(){
    if ( $_POST['debug'] === '1' ) { $debug = TRUE; } else { $debug = FALSE; }
    $newv = TRUE; if ( $_POST['newv'] != 'S' ) { $newv = FALSE;}
    $user = $_POST['user'];
    $pass = $_POST['pass'];
    $file_name = $_FILES['fileToUpload']['name'];
    $temp_name = $_FILES['fileToUpload']['tmp_name'];
    if ( $debug ) { echo 'newv: ' . $newv . ', user: ' . $user . ', pass: ' . $pass . ', fn: ' . $file_name . ', tn: ' . $temp_name . '<br>'; }
    $httpInvoker = new \GuzzleHttp\Client(['auth' => [$user, $pass] ]);

    $parameters = [
        \Dkd\PhpCmis\SessionParameter::BINDING_TYPE => \Dkd\PhpCmis\Enum\BindingType::BROWSER,
        \Dkd\PhpCmis\SessionParameter::BROWSER_URL => CMIS_BROWSER_URL,
        \Dkd\PhpCmis\SessionParameter::BROWSER_SUCCINCT => false,
        \Dkd\PhpCmis\SessionParameter::HTTP_INVOKER_OBJECT => $httpInvoker,
];
    $sessionFactory = new \Dkd\PhpCmis\SessionFactory();
    // If no repository id is defined use the first repository
    if (CMIS_REPOSITORY_ID === null) {
         $repositories = $sessionFactory->getRepositories($parameters);
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = $repositories[0]->getId();
    } else {
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = CMIS_REPOSITORY_ID;
    }

    $site = $_POST['sitio'];
    // La variable path trae tmb el nuevo dir.
    $path = $_POST['path'];
    if ( substr(trim($path), -1) != '/' ) { $path = $path . '/'; }
    if ( $debug ) { echo 'Debug: ' . $debug . ', Site: ' . $site . ', path: ' . $path . '<br>'; }

    $session = $sessionFactory->createSession($parameters);
    $rfname = '/Sitios/' . $site . '/documentLibrary/' . $path;
    if ( $debug ) { echo 'rfname: ' . $rfname . '<br>'; }
    $rf = $session->getObjectByPath($rfname);
    if ( $debug ) { echo '+ [ROOT FOLDER]: ' . $rf->getName() . "<br>\n"; }

    $docproperties = [
		        \Dkd\PhpCmis\PropertyIds::OBJECT_TYPE_ID => 'cmis:document',
			\Dkd\PhpCmis\PropertyIds::NAME => $file_name
                     ];
    if ( ! $newv ) {
        // Si no es nueva versión hacemos subida estandar.
        // Da error si ya existe
        try {
	    $document = $session->createDocument( 
		       $docproperties, $rf, 
		       \GuzzleHttp\Stream\Stream::factory(fopen($temp_name, 'r'))
	              );

            if ( $debug ) {echo "Document has been created. Document Id: " . $document->getId() . "<br>\n"; }
        } catch (\Dkd\PhpCmis\Exception\CmisContentAlreadyExistsException $e) {
            if ( $debug ) { 
               echo "********* ERROR **********<br>\n";
               echo $e->getMessage() . "<br>\n";
	       echo "**************************<br>\n";
            }
        }
    } else {
        $docname = '/Sitios/' . $site . '/documentLibrary/' . $path . $file_name;
        if ( $debug ) { echo 'docname: ' . $docname . '<br>'; }
        // Esto trae el objeto que en este caso es un archivo.
        $document = $session->getObjectByPath($docname);
        if ( $debug ) { echo '+ [ROOT FOLDER]: ' . $document->getName() . "<br>\n"; }
        $checkedOutDocId = $document->getVersionSeriesCheckedOutId();
        if ($checkedOutDocId) {
            if ( $debug ) { echo "Document is already checked out - resuming working copy<br>\n"; }
            $checkedOutDocId = $session->createObjectId($checkedOutDocId);
        } else {
            if ( $debug ) { echo "Checking out document to private working copy (PWC)...<br>"; }
            $checkedOutDocId = $document->checkOut();
        }

        $checkedInDocId = $session->getObject($checkedOutDocId)->checkIn(
                null,
                [ \Dkd\PhpCmis\PropertyIds::DESCRIPTION => 'desde test.php' ],
                \GuzzleHttp\Stream\Stream::factory(fopen($temp_name, 'r')),
                'Checked out/in by system'
        );
        if ( $debug ) { echo "Version ID after Checking in: " . $checkedInDocId->getId() . "<br>\n"; }
    }
}

function creadir() {
    if ( $_POST['debug'] === '1' ) { $debug = TRUE; } else { $debug = FALSE; }
    $user = $_POST['user'];
    $pass = $_POST['pass'];
    if ( $debug ) { echo 'user: ' . $user . ', pass: ' . $pass . '<br>'; }
    $httpInvoker = new \GuzzleHttp\Client(['auth' => [$user, $pass] ]);

    $parameters = [
        \Dkd\PhpCmis\SessionParameter::BINDING_TYPE => \Dkd\PhpCmis\Enum\BindingType::BROWSER,
        \Dkd\PhpCmis\SessionParameter::BROWSER_URL => CMIS_BROWSER_URL,
        \Dkd\PhpCmis\SessionParameter::BROWSER_SUCCINCT => false,
        \Dkd\PhpCmis\SessionParameter::HTTP_INVOKER_OBJECT => $httpInvoker,
];
    $sessionFactory = new \Dkd\PhpCmis\SessionFactory();
    // If no repository id is defined use the first repository
    if (CMIS_REPOSITORY_ID === null) {
         $repositories = $sessionFactory->getRepositories($parameters);
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = $repositories[0]->getId();
    } else {
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = CMIS_REPOSITORY_ID;
    }

    $site = $_POST['sitio'];
    // La variable path trae tmb el nuevo dir.
    $path = dirname($_POST['path']); ### if ( $path === '.' ) { $path = ''; }
    if ( substr(trim($path), -1) != '/' ) { $path = $path . '/'; }
    $dir = basename($_POST['path']);
    if ( $debug ) { echo 'Debug: ' . $debug . ', Site: ' . $site . ', path: ' . $path . ', dir: ' . $dir . '<br>'; }

    $session = $sessionFactory->createSession($parameters);
    $rfname = '/Sitios/' . $site . '/documentLibrary/' . $path;
    if ( $debug ) { echo 'rfname: ' . $rfname . '<br>'; }
    $rf = $session->getObjectByPath($rfname);
    if ( $debug ) { echo '+ [ROOT FOLDER]: ' . $rf->getName() . "<br>\n"; }

    $dirproperties = [ \Dkd\PhpCmis\PropertyIds::OBJECT_TYPE_ID => 'cmis:folder',
		       \Dkd\PhpCmis\PropertyIds::NAME => $dir
                     ];

    if ( $debug ) { echo "Create CMIS Folder<br>\n"; }
    try {
        $folder = $session->createFolder($dirproperties, $rf);
	if ( $debug ) { echo "Folder has been created. Folder Id: " . $folder->getId() . "<br>\n"; }
	http_response_code(200);
    } catch (\Dkd\PhpCmis\Exception\CmisContentAlreadyExistsException $e) {
	if ( $debug ) {
            echo "********* ERROR **********<br>\n";
            echo $e->getMessage() . "<br>\n";
	    echo "**************************<br>\n";
        }
	http_response_code(400);
    }
}

function descargar() {
    if ( $_POST['debug'] === '1' ) { $debug = TRUE; } else { $debug = FALSE; }
    $user = $_POST['user'];
    $pass = $_POST['pass'];
    $name = $_POST['name'];
    if ( $debug ) { echo 'user: ' . $user . ', pass: ' . $pass . ', name: ' . $name . '<br>'; }
    $httpInvoker = new \GuzzleHttp\Client(['auth' => [$user, $pass] ]);

    $parameters = [
        \Dkd\PhpCmis\SessionParameter::BINDING_TYPE => \Dkd\PhpCmis\Enum\BindingType::BROWSER,
        \Dkd\PhpCmis\SessionParameter::BROWSER_URL => CMIS_BROWSER_URL,
        \Dkd\PhpCmis\SessionParameter::BROWSER_SUCCINCT => false,
        \Dkd\PhpCmis\SessionParameter::HTTP_INVOKER_OBJECT => $httpInvoker,
];
    $sessionFactory = new \Dkd\PhpCmis\SessionFactory();
    // If no repository id is defined use the first repository
    if (CMIS_REPOSITORY_ID === null) {
         $repositories = $sessionFactory->getRepositories($parameters);
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = $repositories[0]->getId();
    } else {
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = CMIS_REPOSITORY_ID;
    }

    $site = $_POST['sitio'];
    // La variable path trae tmb el nombre del archivo a bajar
    $path = $_POST['path'];
    if ( $debug ) { echo 'Debug: ' . $debug . ', Site: ' . $site . ', path: ' . $path . '<br>'; }

    $session = $sessionFactory->createSession($parameters);
    $rfname = '/Sitios/' . $site . '/documentLibrary/' . $path;
    if ( $debug ) { echo 'rfname: ' . $rfname . '<br>'; }
    // Esto trae el objeto que en este caso es un archivo.
    $document = $session->getObjectByPath($rfname);
    if ( $debug ) { echo '+ [ROOT FOLDER]: ' . $document->getName() . "<br>\n"; }

    $ext = pathinfo($rfname, PATHINFO_EXTENSION);
    $outf = \GuzzleHttp\Stream\Stream::factory(fopen('/var/www/html/temp/'.$name.'.'.$ext, 'w'));
    $outf->write($document->getContentStream()->getContents());
    $outf->close();

    //Retorna el link del archivo.
    echo 'http://cmis.rec.unicen.edu.ar/temp/'.$name.".".$ext;
}

function listar(){
    if ( $_POST['debug'] === '1' ) { $debug = TRUE; } else { $debug = FALSE; }
    $user = $_POST['user'];
    $pass = $_POST['pass'];
    if ( $debug ) { echo 'user: ' . $user . ', pass: ' . $pass . '<br>'; }
    $httpInvoker = new \GuzzleHttp\Client(['auth' => [$user, $pass] ]);

    $parameters = [
        \Dkd\PhpCmis\SessionParameter::BINDING_TYPE => \Dkd\PhpCmis\Enum\BindingType::BROWSER,
        \Dkd\PhpCmis\SessionParameter::BROWSER_URL => CMIS_BROWSER_URL,
        \Dkd\PhpCmis\SessionParameter::BROWSER_SUCCINCT => false,
        \Dkd\PhpCmis\SessionParameter::HTTP_INVOKER_OBJECT => $httpInvoker,
];
    $sessionFactory = new \Dkd\PhpCmis\SessionFactory();
    // If no repository id is defined use the first repository
    if (CMIS_REPOSITORY_ID === null) {
         $repositories = $sessionFactory->getRepositories($parameters);
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = $repositories[0]->getId();
    } else {
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = CMIS_REPOSITORY_ID;
    }

    $site = $_POST['sitio'];
    // La variable path trae tmb el nuevo dir.
    $path = $_POST['path'];
    if ( $debug ) { echo 'Debug: ' . $debug . ', Site: ' . $site . ', path: ' . $path . '<br>'; }

    $session = $sessionFactory->createSession($parameters);
    $rfname = '/Sitios/' . $site . '/documentLibrary/' . $path;
    if ( $debug ) { echo 'rfname: ' . $rfname . '<br>'; }
    $rf = $session->getObjectByPath($rfname);
    if ( $debug ) { echo '+ [ROOT FOLDER]: ' . $rf->getName() . "<br>\n"; }

    foreach ($rf->getChildren() as $children) {
        if ($children instanceof \Dkd\PhpCmis\Data\FolderInterface) {
            $contenido[] = 'Folder: ' . $children->getName();
        } elseif ($children instanceof \Dkd\PhpCmis\Data\DocumentInterface) {
            $contenido[] = 'Document: ' . $children->getName();
        } else {
            $contenido[] = 'Item: ' . $children->getName();
	}
    }

    for ($i = 0; $i < count($contenido);$i++){
        echo $contenido[$i]. "<br>";
    }
}

function info(){
    if ( $_POST['debug'] === '1' ) { $debug = TRUE; } else { $debug = FALSE; }
    $user = $_POST['user'];
    $pass = $_POST['pass'];
    if ( $debug ) { echo 'user: ' . $user . ', pass: ' . $pass . '<br>'; }
    $httpInvoker = new \GuzzleHttp\Client(['auth' => [$user, $pass] ]);

    $parameters = [
        \Dkd\PhpCmis\SessionParameter::BINDING_TYPE => \Dkd\PhpCmis\Enum\BindingType::BROWSER,
        \Dkd\PhpCmis\SessionParameter::BROWSER_URL => CMIS_BROWSER_URL,
        \Dkd\PhpCmis\SessionParameter::BROWSER_SUCCINCT => false,
        \Dkd\PhpCmis\SessionParameter::HTTP_INVOKER_OBJECT => $httpInvoker,
];
    $sessionFactory = new \Dkd\PhpCmis\SessionFactory();
    // If no repository id is defined use the first repository
    if (CMIS_REPOSITORY_ID === null) {
         $repositories = $sessionFactory->getRepositories($parameters);
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = $repositories[0]->getId();
    } else {
         $parameters[\Dkd\PhpCmis\SessionParameter::REPOSITORY_ID] = CMIS_REPOSITORY_ID;
    }

    $site = $_POST['sitio'];
    // La variable path trae tmb el archivo.
    $path = $_POST['path'];
    if ( $debug ) { echo 'Debug: ' . $debug . ', Site: ' . $site . ', path: ' . $path . '<br>'; }

    $session = $sessionFactory->createSession($parameters);
    $docname = '/Sitios/' . $site . '/documentLibrary/' . $path;
    if ( $debug ) { echo 'docname: ' . $docname . '<br>'; }
    $doc = $session->getObjectByPath($docname);
    if ( $debug ) { echo '+ [ROOT FOLDER]: ' . $doc->getName() . "<br>\n"; }

    foreach ($doc->getAllVersions() as $version) {
        echo $version->getVersionLabel() . '<br>';
    }
}

$accion = $_GET['accion'];
switch ($accion) {
    case "cargar":
        cargar();
        break;
    case "descargar":
        descargar();
	break;
    case "listar":
	listar();
	break;
    case "creadir":
        creadir();
        break;
    case "info":
        info();
        break;
}

?>
